<?php
/**
 * ShopEx licence
 *
 * @copyright  Copyright (c) 2005-2015 ShopEx Technologies Inc. (http://www.shopex.cn)
 * @license  http://ecos.shopex.cn/ ShopEx License
 */

// 购物券规则表
return  array(
    'columns' => array(
        'voucher_id' => array(
            'type' => 'number',
            'required' => true,
            //'pkey' => true,
            'autoincrement' => true,
            'comment' => app::get('syspromotion')->_('购物券id'),
        ),
        'voucher_name' => array(
            //'type' => 'varchar(255)',
            'type' => 'string',
            'required' => true,
            'in_list' => true,
            'default_in_list' => true,
            'width' => 110,
            'label' => app::get('syspromotion')->_('购物券名称'),
            'comment' => app::get('syspromotion')->_('购物券名称'),
        ),
        'voucher_desc' => array(
            //'type' => 'varchar(255)',
            'type' => 'string',
            'required' => true,
            'in_list' => true,
            'width' => 110,
            'label' => app::get('syspromotion')->_('购物券描述'),
            'comment' => app::get('syspromotion')->_('购物券描述'),
        ),
        'valid_status' => array(
            'type' => 'bool',
            'default' => '1', //0失效，1有效
            'required'=> true,
            'in_list' => true,
            'default_in_list' => true,
            'label' => app::get('syspromotion')->_('有效状态'),
            'comment' => app::get('syspromotion')->_('有效状态'),
        ),
        'promotion_tag' => array(
            //'type' => 'varchar(15)',
            'type' => 'string',
            'length' => 15,
            'required' => true,
            'label' => app::get('syspromotion')->_('促销标签'),
            'comment' => app::get('syspromotion')->_('促销标签'),
        ),
        'used_platform' => array(
            'type' => 'string',//pc wap app 多个逗号隔开
            'required' => true,
            'in_list' => true,
            'default_in_list' => true,
            'label' => app::get('syspromotion')->_('使用平台'),
            'comment' => app::get('syspromotion')->_('使用平台'),
        ),
        'valid_grade' => array(
            //'type' => 'varchar(255)',
            'type' => 'string',
            'default' => '',
            'required' => true,
            'label' => app::get('syspromotion')->_('会员级别集合'),
        ),
        'shoptype' => array(
            'type' => 'string',
            'default' => '',
            'required' => true,
            'label' => app::get('syspromotion')->_('支持店铺类型'),//逗号隔开的字符串
        ),
        'limit_cat' => array(
            'type' => 'string',
            'default' => '',
            'required' => true,
            'label' => app::get('syspromotion')->_('支持商品类目'),//逗号隔开的字符串
        ),
        'subsidy_proportion' => array(
            'type' => 'string',
            'default' => '',
            'required' => true,
            'label' => app::get('syspromotion')->_('平台补贴比例'),
        ),
        'limit_money' => array(
            'type' => 'money',
            'default' => '0',
            'in_list' => true,
            'default_in_list' => true,
            'width' => '50',
            'order' => 14,
            'label' => app::get('syspromotion')->_('满足条件金额'),
            'comment' => app::get('syspromotion')->_('满足条件金额'),
        ),
        'deduct_money' => array(
            'type' => 'money',
            'default' => '0',
            'in_list' => true,
            'default_in_list' => true,
            'width' => '50',
            'order' => 14,
            'label' => app::get('syspromotion')->_('购物券金额'),
            'comment' => app::get('syspromotion')->_('购物券金额'),
        ),
        'max_gen_quantity' => array(
            'type' => 'number',
            'default' => '0',
            'in_list' => true,
            'default_in_list' => true,
            'width' => '50',
            'order' => 14,
            'label' => app::get('syspromotion')->_('最大购物券号码数量'),
            'comment' => app::get('syspromotion')->_('最大购物券号码数量'),
        ),
        'send_vouchercode_quantity' => array(
            'type' => 'number',
            'default' => '0',
            'in_list' => true,
            'default_in_list' => true,
            'width' => '50',
            'order' => 14,
            'label' => app::get('syspromotion')->_('已生成的购物券号码数量'),
            'comment' => app::get('syspromotion')->_('已生成购物券号码数量'),
        ),
        'use_vouchercode_quantity' => array(
            'type' => 'number',
            'default' => '0',
            'in_list' => true,
            'default_in_list' => true,
            'width' => '50',
            'order' => 14,
            'label' => app::get('syspromotion')->_('已使用的购物券号码数量'),
            'comment' => app::get('syspromotion')->_('已使用的购物券号码数量'),
        ),
        'userlimit_quantity' => array(
            'type' => 'number',
            'default' => '0',
            'in_list' => true,
            'width' => '50',
            'order' => 14,
            'label' => app::get('syspromotion')->_('用户总计可领取购物券数量'),
            'comment' => app::get('syspromotion')->_('用户总计可领取购物券数量'),
        ),
        'apply_begin_time' => array(
            'type' => 'time',
            'default' => 0,
            'required' => true,
            'in_list' => true,
            'default_in_list' => true,
            'filterdefault' => true,
            'order' => 7,
            'label' => app::get('syspromotion')->_('申请开始时间'),
            'comment' => app::get('syspromotion')->_('申请开始时间'),
        ),
        'apply_end_time' => array(
            'type' =>'time',
            'default' => 0,
            'required' => true,
            'in_list' => true,
            'default_in_list' => true,
            'filterdefault' => true,
            'order' => 8,
            'label' => app::get('syspromotion')->_('申请结束时间'),
            'comment' => app::get('syspromotion')->_('申请结束时间'),
        ),
        'cansend_start_time' => array(
            'type' => 'time',
            'width' => '100',
            'label' => app::get('syspromotion')->_('发购物券开始时间'),
            'comment' => app::get('syspromotion')->_('发购物券开始时间'),
        ),
        'cansend_end_time' => array(
            'type' => 'time',
            'width' => '100',
            'label' => app::get('syspromotion')->_('发购物券结束时间'),
            'comment' => app::get('syspromotion')->_('发购物券结束时间'),
        ),
        'canuse_start_time' => array(
            'type' => 'time',
            'in_list' => true,
            'default_in_list' => true,
            'width' => '100',
            'label' => app::get('syspromotion')->_('购物券生效时间'),
            'comment' => app::get('syspromotion')->_('购物券生效时间'),
            'orderby' => true,
        ),
        'canuse_end_time' => array(
            'type' => 'time',
            'in_list' => true,
            'default_in_list' => true,
            'width' => '100',
            'label' => app::get('syspromotion')->_('购物券失效时间'),
            'comment' => app::get('syspromotion')->_('购物券失效时间'),
            'orderby' => true,
        ),
        'created_time' => array(
            'type' => 'time',
            'in_list' => true,
            'default_in_list' => true,
            'width' => '100',
            'label' => app::get('syspromotion')->_('建券时间'),
            'comment' => app::get('syspromotion')->_('建券时间'),
            'orderby' => true,
        ),
    ),
    'primary' => 'voucher_id',
    'index' => array(
        'ind_created_time' => ['columns' => ['created_time']],
    ),
    'comment' => app::get('syspromotion')->_('购物券表'),
);

